package ru.ulstu.extractor.generation.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PostMapping;
import ru.ulstu.extractor.generation.model.GenerationForm;
import ru.ulstu.extractor.generation.service.GenerationService;
import springfox.documentation.annotations.ApiIgnore;

import static ru.ulstu.extractor.core.Route.GENERATION;

@Controller
@ApiIgnore
public class GenerationController {
    private final GenerationService generationService;

    public GenerationController(GenerationService generationService) {
        this.generationService = generationService;
    }

    @GetMapping(GENERATION)
    public String getGenerationsPage(Model model) {
        model.addAttribute("generationForm", new GenerationForm());
        return GENERATION;
    }

    @PostMapping(GENERATION)
    public String setGenerationParams(Model model, @ModelAttribute GenerationForm generationForm) {
        model.addAttribute("generationForm", generationForm);
        generationService.generate(generationForm);
        return GENERATION;
    }
}
