package ru.ulstu.extractor.gitrepository.controler;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import ru.ulstu.extractor.gitrepository.repository.GitRepositoryRepository;
import springfox.documentation.annotations.ApiIgnore;

import java.util.stream.Collectors;

import static ru.ulstu.extractor.core.Route.DELETE_INDEXED_REPOSITORY;
import static ru.ulstu.extractor.core.Route.LIST_INDEXED_REPOSITORIES;
import static ru.ulstu.extractor.gitrepository.model.GitRepository.GENERATED_REPOSITORY_ID;

@Controller
@ApiIgnore
public class RepositoryController {
    private final GitRepositoryRepository gitRepositoryRepository;

    public RepositoryController(GitRepositoryRepository gitRepositoryRepository) {
        this.gitRepositoryRepository = gitRepositoryRepository;
    }

    @GetMapping(LIST_INDEXED_REPOSITORIES)
    public String indexNewRepo(Model model) {
        model.addAttribute("repositories", gitRepositoryRepository.findAll()
                .stream()
                .filter(r -> !r.getId().equals(GENERATED_REPOSITORY_ID))
                .collect(Collectors.toList()));
        return LIST_INDEXED_REPOSITORIES;
    }

    @GetMapping(DELETE_INDEXED_REPOSITORY)
    public String deleteRepo(Model model,
                             @RequestParam Integer id) {
        gitRepositoryRepository.deleteById(id);
        model.addAttribute("repositories", gitRepositoryRepository.findAll()
                .stream()
                .filter(r -> !r.getId().equals(GENERATED_REPOSITORY_ID))
                .collect(Collectors.toList()));
        return "redirect:/" + LIST_INDEXED_REPOSITORIES;
    }
}
